unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ScktComp, ComCtrls, Psock, NMEcho, Menus, ClipBrd,
  Unit2, ShellApi;

type
  TForm1 = class(TForm)
    Bevel1: TBevel;
    GroupBox1: TGroupBox;
    lblServidor: TLabel;
    editNombreServidor: TEdit;
    btnAnadir: TButton;
    Echo: TNMEcho;
    ListView: TListView;
    Bevel2: TBevel;
    PopupMenuListView: TPopupMenu;
    CopiarIP: TMenuItem;
    CopiarNombre: TMenuItem;
    GroupBox2: TGroupBox;
    ComboBoxBuscar: TComboBox;
    EditBuscar: TEdit;
    btnBuscar: TButton;
    btnSiguiente: TButton;
    N1: TMenuItem;
    ComprobarTodos: TMenuItem;
    ComprobarEste: TMenuItem;
    N2: TMenuItem;
    Explorar: TMenuItem;
    N3: TMenuItem;
    Eliminar: TMenuItem;
    ComboBoxTipo: TComboBox;
    procedure btnAnadirClick(Sender: TObject);
    procedure EchoHostResolved(Sender: TComponent);
    procedure EchoInvalidHost(var Handled: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure editNombreServidorKeyPress(Sender: TObject; var Key: Char);
    procedure ListViewColumnClick(Sender: TObject; Column: TListColumn);
    procedure CopiarIPClick(Sender: TObject);
    procedure CopiarNombreClick(Sender: TObject);
    procedure btnBuscarClick(Sender: TObject);
    procedure EditBuscarKeyPress(Sender: TObject; var Key: Char);
    procedure btnSiguienteClick(Sender: TObject);
    procedure ComprobarTodosClick(Sender: TObject);
    procedure ComprobarEsteClick(Sender: TObject);
    procedure ListViewDblClick(Sender: TObject);
    procedure ExplorarClick(Sender: TObject);
    procedure EliminarClick(Sender: TObject);
    procedure ListViewMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
    function AjustarIP ( IP : string ) : string;
    function Mayusculas ( const cad : string ) : string;
    function EsSubString ( const peque, grande : string ) : boolean;
    procedure ErrorConectandoConServidor;
    procedure AnnadeAlComboBoxTipo ( Tipo : string );
  public
    { Public declarations }
    procedure DarDeAlta ( Servidor, IP, Tipo : string );
    procedure CargarFichero;
    procedure GuardarFichero;
  end;

var
  Form1: TForm1;
  OrdenadoPor : integer; // 1=IP   2=Servidor   3=Tipo

  BuscaPosActual : integer;
  BuscaPuedoSig : boolean;

  frmComprobarTodos : TfrmComprobarTodos;

  AnadirEntradaAunqueError : boolean; // "<Host not found>"
  AntTipo : string;


{ *************************************************************** }

Const ProgramID = 'IP Manager v1.1';
      NombreBD = 'IP_Data.dat';
      NombreAUX = 'IP_Temp.tmp';
      AnchoColIP = 100;
      AnchoColServidor = 190;
      AnchoColTipo = 107;
      AnchoListView = AnchoColIP+AnchoColServidor+AnchoColTipo+4;

{ *************************************************************** }

implementation

{$R *.DFM}


{ *************************************************************** }

procedure TForm1.btnAnadirClick(Sender: TObject);
begin

  if (editNombreServidor.Text = '') then begin
    MessageBox(Self.Handle,PChar('Introduzca el nombre de un Servidor'),PChar('Error!'),MB_OK+MB_ICONEXCLAMATION);
    editNombreServidor.SetFocus;
    exit;
  end;

  Echo.Host := EditNombreServidor.Text;
  Caption := ProgramID + '  (Conectando con '+Echo.Host+' ...)';
  AnadirEntradaAunqueError := false;
  try
    Echo.ResolveRemoteHost;
  except
    on E: Exception do ErrorConectandoConServidor;
  end;

end;


{ *************************************************************** }

procedure TForm1.EchoHostResolved(Sender: TComponent);
var i : integer;
begin

  Caption := ProgramID + '  (Terminando conexin con '+Echo.Host+' ...)';

  // Aadir a la lista Echo.RemoteIP
  DarDeAlta ( Echo.Host, Echo.RemoteIP, ComboBoxTipo.Text );
  GuardarFichero;
  Caption := ProgramID;

  i := 0;
  while ( i<ListView.Items.Count ) and ( ListView.Items.Item[i].SubItems.Strings[1] <> Echo.Host ) do inc(i);
  ListView.SetFocus;
  ListView.Items.Item[i].MakeVisible(true);
  ListView.Items.Item[i].Selected := true;
  ListView.Items.Item[i].Focused := true;

end;


{ *************************************************************** }

procedure TForm1.EchoInvalidHost(var Handled: Boolean);
begin
  MessageBox(Self.Handle,PChar('Servidor no econtrado'),PChar('Error!'),MB_OK+MB_ICONEXCLAMATION);
  Caption := ProgramID;
end;


{ *************************************************************** }

Procedure TForm1.CargarFichero;
var IP, Servidor, Tipo : string;
    f : TextFile;
begin

  AssignFile ( f , NombreBD );

  If not FileExists(NombreBD) then begin
    rewrite(f);
    closeFile(f);
    exit;
  end;

  reset(f);

  while not eof(f) do begin
    readln(f, Servidor);
    readln(f, IP);
    readln(f, Tipo);
    DarDeAlta ( Servidor, IP, Tipo );
  end;

  closeFile(f);

end;


{ *************************************************************** }

Procedure TForm1.GuardarFichero;
var IP, Servidor, Tipo : string;
    f : TextFile;
    i : integer;
    ComboBoxTipoAntText : string;
begin

  AssignFile ( f , NombreBD );
  rewrite(f);

  ComboBoxTipoAntText := ComboBoxTipo.Text;
  ComboBoxTipo.Clear;

  for i:=0 to ListView.Items.Count-1 do begin
    IP := ListView.Items.Item[i].SubItems.Strings[0];
    Servidor := ListView.Items.Item[i].SubItems.Strings[1];
    Tipo := ListView.Items.Item[i].SubItems.Strings[2];
    Writeln(f, Servidor);
    Writeln(f, IP);
    Writeln(f, Tipo);
    AnnadeAlComboBoxTipo(Tipo);
  end;

  ComboBoxTipo.Text := ComboBoxTipoAntText;
  closeFile(f);

end;


{ *************************************************************** }

procedure TForm1.FormCreate(Sender: TObject);
begin

  Top  := (Screen.Height SHR 1) - ( Height SHR 1 );
  Left := (Screen.Width SHR 1)  - ( Width SHR 1 );

  ListView.Width := AnchoListView;
  ListView.Columns.Items[0].Width := 0;
  ListView.Columns.Items[1].Width := AnchoColIP;
  ListView.Columns.Items[2].Width := AnchoColServidor;
  ListView.Columns.Items[3].Width := AnchoColTipo;

  OrdenadoPor := 2;
  CargarFichero;

  BuscaPosActual := 0;
  BuscaPuedoSig := false;

end;


{ *************************************************************** }

procedure TForm1.editNombreServidorKeyPress(Sender: TObject;
  var Key: Char);
begin
  if Key=#13 then btnAnadirClick(Self);
end;


{ *************************************************************** }

procedure TForm1.DarDeAlta ( Servidor, IP, Tipo : string );
var i : integer;
    item : TListItem;
begin

  i:=0;

  while ( i < ListView.Items.Count ) do begin
    if ListView.Items.Item[i].SubItems.Strings[1]=Servidor then begin
      ListView.Items.Delete(i);
      i := 0;
    end else
      inc(i);
  end;

  item := ListView.Items.Add;
  item.SubItems.Add(IP);
  item.SubItems.Add(Servidor);
  item.SubItems.Add(Tipo);

  Case OrdenadoPor of
    1 : item.Caption := AjustarIP(IP) + Mayusculas(Servidor) + Mayusculas(Tipo);
    2 : item.Caption := Mayusculas(Servidor) + Mayusculas(Tipo) + AjustarIP(IP);
    3 : item.Caption := Mayusculas(Tipo) + Mayusculas(Servidor) + AjustarIP(IP);
  end;

  if ListView.Items.Count>12 then
    ListView.Columns.Items[3].Width := AnchoColTipo-16
  else
    ListView.Columns.Items[3].Width := AnchoColTipo;

  AnnadeAlComboBoxTipo(Tipo);

end;


{ *************************************************************** }

procedure TForm1.ListViewColumnClick(Sender: TObject; Column: TListColumn);
begin

  if ((Column.Caption = 'Direccin IP') and (OrdenadoPor<>1)) then begin
    GuardarFichero;
    OrdenadoPor := 1;
    ListView.Items.Clear;
    CargarFichero;
  end else if ((Column.Caption = 'Servidor') and (OrdenadoPor<>2)) then begin
    GuardarFichero;
    OrdenadoPor := 2;
    ListView.Items.Clear;
    CargarFichero;
  end else if ((Column.Caption = 'Tipo') and (OrdenadoPor<>3)) then begin
    GuardarFichero;
    OrdenadoPor := 3;
    ListView.Items.Clear;
    CargarFichero;
  end;

end;


{ *************************************************************** }

Function TForm1.AjustarIP ( IP : string ) : string;
var devolver : string;
    i,cont : integer;
begin

  devolver := '';

  i := length(IP);
  cont := 0;

  if IP[1]='<' then begin  //  WARNING!!!  '<Not Found>'
    i := 0;     // Condicin de Salida forzada. :->
    Cont := 3;  // Pa que no aada nada.
    Devolver := '000.000.000.000';
  end;

  while (i>0) do begin
    if IP[i]<>'.' then begin
      inc(cont); // Cuenta cuntos dgitos van 'xxx.xxx.xxx.xxx'.
      devolver := IP[i]+devolver;
    end else begin
      while (cont<3) do begin
        devolver := '0'+devolver;
        inc(cont);
      end;
      devolver := '.'+devolver;
      cont := 0;
    end;
    dec(i);
  end;

  while (cont<3) do begin
    devolver := '0'+devolver;
    inc(cont);
  end;

  Result := devolver;

end;


{ *************************************************************** }

procedure TForm1.CopiarIPClick(Sender: TObject);
var i : integer;
    encontrado : boolean;
begin

  i := 0;
  encontrado := false;

  while ( i < ListView.Items.Count ) and not encontrado do
    if not ListView.Items.item[i].Selected then
      inc(i)
    else
      encontrado := true;

  if encontrado then ClipBoard.SetTextBuf(PChar(ListView.Items.Item[i].SubItems.Strings[0]));

end;


{ *************************************************************** }

procedure TForm1.CopiarNombreClick(Sender: TObject);
var i : integer;
    encontrado : boolean;
begin

  i := 0;
  encontrado := false;

  while ( i < ListView.Items.Count ) and not encontrado do
    if not ListView.Items.item[i].Selected then
      inc(i)
    else
      encontrado := true;

  if encontrado then ClipBoard.SetTextBuf(PChar(ListView.Items.Item[i].SubItems.Strings[1]));

end;


{ *************************************************************** }

function TForm1.Mayusculas ( const cad : string ) : string;
var i : integer;
    devolver : string;
begin

  devolver := '';

  for i := 1 to length(cad) do
    case cad[i] of
      '' : devolver := devolver+'';
      '' : devolver := devolver+'A';
      '' : devolver := devolver+'E';
      '' : devolver := devolver+'I';
      '' : devolver := devolver+'O';
      '' : devolver := devolver+'U';
      else  devolver := devolver+UpCase(cad[i]);
    end;

  Result := devolver;  

end;


{ *************************************************************** }

function TForm1.EsSubString ( const peque, grande : string ) : boolean;
// Para que esta funcin rule bien, psale las cadenas en Maysculas.
var i,j,k : integer;
    encontrado : boolean;
begin

  encontrado := false;

  i := 1;

  if (grande='') then begin
    encontrado := (peque='');
    i := length(grande)+1; // Condicin cutre de salida.  ':>
  end;

  while (not encontrado) and (i+length(peque)-1 <= length(grande)) do begin

    if ( grande[i]=peque[1] ) then begin

      j := 2; k := 1;  // Comprobar a partir del 2 carcter.
      if ( length(peque)=1 ) then encontrado := true;

      while ( not encontrado ) and ( j<=length(peque) ) and ( i+k <= length(grande) ) and ( grande[i+k]=peque[j] ) do begin

        inc(j);
        inc(k);
        if ( j> length(peque) ) then encontrado := true;

      end;

    end;

    inc(i);

  end;

  Result := encontrado;

end;


{ *************************************************************** }

procedure TForm1.btnBuscarClick(Sender: TObject);
var Encontrado : boolean;
    Buscado : string;
begin

  if (EditBuscar.Text='') then begin
    MessageBox(Self.Handle,PChar('Bsqueda no vlida'),PChar('Error!'),MB_OK+MB_ICONEXCLAMATION);
    editBuscar.SetFocus;
    exit;
  end;

  BuscaPosActual := 0;
  Encontrado := false;
  BuscaPuedoSig := false;

  Buscado := Mayusculas(EditBuscar.Text);

  while (not Encontrado) and (BuscaPosActual<ListView.Items.Count) do begin
    if (ComboBoxBuscar.Text = 'Dir. IP') then
      Encontrado := EsSubString(Buscado,Mayusculas(ListView.Items.Item[BuscaPosActual].SubItems.Strings[0]))
    else if (ComboBoxBuscar.Text = 'Servidor') then
      Encontrado := EsSubString(Buscado,Mayusculas(ListView.Items.Item[BuscaPosActual].SubItems.Strings[1]))
    else if (ComboBoxBuscar.Text = 'Tipo') then
      Encontrado := EsSubString(Buscado,Mayusculas(ListView.Items.Item[BuscaPosActual].SubItems.Strings[2]));
    if (not Encontrado) then inc(BuscaPosActual);
  end;

  if Encontrado then begin
    BuscaPuedoSig := true;
    ListView.SetFocus;
    ListView.Items.Item[BuscaPosActual].MakeVisible(true);
    ListView.Items.Item[BuscaPosActual].Selected := true;
    ListView.Items.Item[BuscaPosActual].Focused := true;
  end else begin
    MessageBox(Self.Handle,PChar('No se encontraron equivalencias'),PChar('Fin de la bsqueda'),MB_OK+MB_ICONINFORMATION);
  end;

  btnSiguiente.Enabled := BuscaPuedoSig;

end;


{ *************************************************************** }

procedure TForm1.EditBuscarKeyPress(Sender: TObject; var Key: Char);
begin
  btnSiguiente.Enabled := false;
  BuscaPuedoSig := false;
  if key=#13 then btnBuscarClick(Self);
end;


{ *************************************************************** }

procedure TForm1.btnSiguienteClick(Sender: TObject);
var Encontrado : boolean;
    Buscado : string;
begin

  inc(BuscaPosActual);
  Encontrado := false;
  BuscaPuedoSig := false;

  Buscado := Mayusculas(EditBuscar.Text);

  while (not Encontrado) and (BuscaPosActual<ListView.Items.Count) do begin
    if (ComboBoxBuscar.Text = 'Dir. IP') then
      Encontrado := EsSubString(Buscado,Mayusculas(ListView.Items.Item[BuscaPosActual].SubItems.Strings[0]))
    else if (ComboBoxBuscar.Text = 'Servidor') then
      Encontrado := EsSubString(Buscado,Mayusculas(ListView.Items.Item[BuscaPosActual].SubItems.Strings[1]))
    else if (ComboBoxBuscar.Text = 'Tipo') then
      Encontrado := EsSubString(Buscado,Mayusculas(ListView.Items.Item[BuscaPosActual].SubItems.Strings[2]));
    if (not Encontrado) then inc(BuscaPosActual);
  end;

  if Encontrado then begin
    BuscaPuedoSig := true;
    btnSiguiente.Enabled := true;
    ListView.SetFocus;
    ListView.Items.Item[BuscaPosActual].MakeVisible(true);
    ListView.Items.Item[BuscaPosActual].Selected := true;
    ListView.Items.Item[BuscaPosActual].Focused := true;
  end else begin
    BuscaPuedoSig := false;
    btnSiguiente.Enabled := false;
    MessageBox(Self.Handle,PChar('No se encontraron ms equivalencias'),PChar('Fin de la bsqueda'),MB_OK+MB_ICONINFORMATION);
  end;

end;


{ *************************************************************** }

procedure TForm1.ComprobarTodosClick(Sender: TObject);
begin

  GuardarFichero;
  frmComprobarTodos := TfrmComprobarTodos.Create(Self);

  frmComprobarTodos.Left := Left + (Width SHR 1) - (frmComprobarTodos.Width SHR 1);
  frmComprobarTodos.Top := Top + (Height SHR 1) - (frmComprobarTodos.Height SHR 1);

  frmComprobarTodos.Show;
  frmComprobarTodos.Comprobar;

end;


{ *************************************************************** }

procedure TForm1.ErrorConectandoConServidor;
begin

  if not AnadirEntradaAunqueError then
    MessageBox(Self.Handle,PChar('Error al conectar con el Servidor "'+Echo.Host+'"'),PChar('Error'),MB_OK+MB_ICONERROR)
  else
    DarDeAlta(Echo.Host,'<Host not found>',AntTipo);
  Caption := ProgramID;
end;


{ *************************************************************** }

procedure TForm1.ComprobarEsteClick(Sender: TObject);
var i : integer;
begin

  i := 0;
  while (i<ListView.Items.Count) and (not ListView.Items.Item[i].Selected) do inc(i);

  if (i<ListView.Items.Count) then begin

    Echo.Host := ListView.Items.Item[i].SubItems.Strings[1];
    Caption := ProgramID + '  (Conectando con '+Echo.Host+' ...)';

    AnadirEntradaAunqueError := true;
    AntTipo := ListView.Items.Item[i].SubItems.Strings[2];

    try
      Echo.ResolveRemoteHost;
    except
      on E: Exception do ErrorConectandoConServidor;
    end;

    ListView.SetFocus;
    ListView.Items.Item[i].Selected := true;
    ListView.Items.Item[i].Focused := true;

  end;

end;


{ *************************************************************** }

procedure TForm1.ListViewDblClick(Sender: TObject);
var i : integer;
begin

  i := 0;
  while ( i<ListView.Items.Count ) and ( not ListView.Items.Item[i].Selected ) do inc(i);

  if (i<ListView.Items.Count) then begin
    Caption := ProgramID + '  (Explorando "http://'+ListView.Items.Item[i].SubItems.Strings[0]+'")';
    ShellExecute(Form1.Handle,nil,PChar('http://'+ListView.Items.Item[i].SubItems.Strings[0]),'','',SW_SHOWMAXIMIZED);
    Caption := ProgramID;
  end;  

end;


{ *************************************************************** }

procedure TForm1.ExplorarClick(Sender: TObject);
begin
  ListViewDblClick(Self);
end;


{ *************************************************************** }

procedure TForm1.EliminarClick(Sender: TObject);
var i : integer;
begin

  i := 0;
  while ( i<ListView.Items.Count ) and ( not ListView.Items.Item[i].Selected ) do inc(i);

  if (i<ListView.Items.Count) then begin

    ListView.Items.Delete(i);
    GuardarFichero;

    if (ListView.Items.Count > 0) then begin
      ListView.SetFocus;
      ListView.Items.Item[0].MakeVisible(true);
      ListView.Items.Item[0].Selected := true;
      ListView.Items.Item[0].Focused := true;
    end;

  end;

end;


{ *************************************************************** }

procedure TForm1.ListViewMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var i : integer;
begin

  i := 0;
  while ( i<ListView.Items.Count ) and ( not ListView.Items.Item[i].Selected ) do inc(i);

  if (i<ListView.Items.Count) then begin
    Explorar.Enabled := true;
    Eliminar.Enabled := true;
    CopiarIP.Enabled := true;
    CopiarNombre.Enabled := true;
    ComprobarEste.Enabled := true;
  end else begin
    Explorar.Enabled := false;
    Eliminar.Enabled := false;
    CopiarIP.Enabled := false;
    CopiarNombre.Enabled := false;
    ComprobarEste.Enabled := false;
  end;

end;


{ *************************************************************** }

procedure TForm1.AnnadeAlComboBoxTipo ( Tipo : string );
var i : integer;
    duplicado : boolean;
    TipoMayusculas : string;
begin

  duplicado := false;
  i := 0;
  TipoMayusculas := Mayusculas(Tipo);

  while (not duplicado) and (i<ComboBoxTipo.Items.Count) do begin
    if Mayusculas(ComboBoxTipo.Items.Strings[i])=TipoMayusculas then duplicado := true;
    inc(i);
  end;

  if not duplicado then ComboBoxTipo.Items.Add(Tipo);

end;


{ *************************************************************** }

end.
