unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Gauges, ExtCtrls, Psock, NMEcho;

type
  TfrmComprobarTodos = class(TForm)
    Bevel1: TBevel;
    EditComprobando: TEdit;
    Timer: TTimer;
    Echo2: TNMEcho;
    Panel1: TPanel;
    Bevel3: TBevel;
    Bevel2: TBevel;
    ProgressBar: TGauge;
    procedure FormCreate(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure Echo2InvalidHost(var Handled: Boolean);
    procedure Echo2HostResolved(Sender: TComponent);
    procedure EditComprobandoMouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
    procedure ErrorConectandoConServidor;
    procedure MoverVentana;
  public
    { Public declarations }
    procedure Comprobar;
  end;

var
  frmComprobarTodos: TfrmComprobarTodos;
  ComprobandoDNS : boolean; // flag para el timer.
  fAUX : TextFile;
  TotalServidores, ServidorActual : integer;
  YaPuedoChapar : Boolean;
  AntTipo : string;

implementation

{$R *.DFM}

Uses Unit1;

{ *************************************************************** }

procedure TfrmComprobarTodos.Comprobar;
var fBD : TextFile;
    lin : string;
begin

  YaPuedoChapar := false;
  TotalServidores := 0;

  AssignFile ( fBD, Unit1.NombreBD );
  AssignFile ( fAUX , Unit1.NombreAUX );

  reset ( fBD );
  rewrite ( fAUX );

  while (not eof(fBD) ) do begin
    readln ( fBD , lin );  // Leo el Nombre del Servidor...
    writeln ( fAUX , lin );
    readln ( fBD , lin );  // Leo el IP...
    readln ( fBD , lin );  // Y leo el Tipo...
    writeln ( fAUX , lin );
    inc ( TotalServidores );
  end;

  closeFile ( fBD );
  closeFile ( fAUX );

  ProgressBar.MaxValue := TotalServidores;

  reset ( fAUX );

  ServidorActual := 0;

  Form1.ListView.Items.Clear;
  Timer.Interval := 100;

end;


{ *************************************************************** }

procedure TfrmComprobarTodos.FormCreate(Sender: TObject);
begin
  ProgressBar.Progress := 0;
  EditComprobando.Text := 'Comprobando:';
end;


{ *************************************************************** }

procedure TfrmComprobarTodos.TimerTimer(Sender: TObject);
var lin : string;
begin

  if (not ComprobandoDNS) and (not eof(fAUX)) then begin

    ComprobandoDNS := true;
    readln ( fAUX , lin );
    readln ( fAUX , AntTipo );  // Es por mantener el "Tipo".  :)
    inc ( ServidorActual );
    ProgressBar.Progress := ServidorActual;
    EditComprobando.Text := 'Comprobando: ' + lin;

    if eof(fAUX) then YaPuedoChapar := true;

    Echo2.Host := lin;
    try
      Echo2.ResolveRemoteHost;
    except
      on E: Exception do ErrorConectandoConServidor;
    end;

  end;

end;


{ *************************************************************** }

procedure TfrmComprobarTodos.ErrorConectandoConServidor;
begin
  Form1.DarDeAlta( Echo2.Host, '<Host not found>', AntTipo );
  ComprobandoDNS := false;
  if YaPuedoChapar then begin
    CloseFile ( fAUX );
    Form1.GuardarFichero;
    Self.Release;
  end;
end;


{ *************************************************************** }

procedure TfrmComprobarTodos.Echo2InvalidHost(var Handled: Boolean);
begin
  Form1.DarDeAlta( Echo2.Host, '<Invalid Host>', AntTipo );
  ComprobandoDNS := false;
  if YaPuedoChapar then begin
    CloseFile ( fAUX );
    Form1.GuardarFichero;
    Self.Release;
  end;
end;


{ *************************************************************** }

procedure TfrmComprobarTodos.Echo2HostResolved(Sender: TComponent);
begin
  Form1.DarDeAlta( Echo2.Host, Echo2.RemoteIP, AntTipo );
  ComprobandoDNS := false;
  if YaPuedoChapar then begin
    CloseFile ( fAUX );
    Erase (fAUX);
    Form1.GuardarFichero;
    Self.Release;
  end;
end;


{ *************************************************************** }

procedure TfrmComprobarTodos.MoverVentana;
const SC_DragMove = $F012;
begin
  ReleaseCapture;
  Self.perform(WM_SysCommand, SC_DragMove, 0);
end;


{ *************************************************************** }

procedure TfrmComprobarTodos.EditComprobandoMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if ssLeft in Shift then MoverVentana;
end;


{ *************************************************************** }

end.
